#include "plugin.h"
#include "plugapi.h"
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
	struct mhandle *h;
	struct motion_plugin *p;
	int inp1, inp2;

	if (argc < 4) {
		printf("Usage: %s <plugin path> <int 1> <int 2>.\n", argv[0]);
		exit(1);
	}

	printf("Loading plugin from '%s'...\n", argv[1]);
	h = plugin_load(argv[1], 0);
	if (!h) {
		printf("Failed to load module.\n");
		exit(1);
	}

	p = plugin_data(h);

	printf("\nPlugin information\n");
	printf("==================\n");
	printf("Plugin name.......: %s\n", p->name);
	printf("Plugin version....: %s\n", p->version);
	printf("Plugin author.....: %s\n", p->author);
	printf("Plugin homepage...: %s\n", p->homepage);
	printf("Plugin type.......: %s\n\n",
	       (p->flags & M_PLUGIN_MULTIPLY) ? "multiplication" : 
		   (p->flags & M_PLUGIN_DIVIDE) ? "division" : "unknown");
	
	inp1 = atoi(argv[2]);
	inp2 = atoi(argv[3]);

	if (p->flags & M_PLUGIN_MULTIPLY) {
		printf("Multiplying %d with %d, result = %d\n", inp1, inp2,
		       p->api.mul_api.multiply(inp1, inp2));
	} else if (p->flags & M_PLUGIN_DIVIDE) {
		printf("Dividing %d with %d, result = %d\n", inp1, inp2,
		       p->api.div_api.divide(inp1, inp2));
	} else {
		printf("Don't know what to do...");
	}
					
	printf("Unloading/closing the plugin...\n");
	plugin_close(h);
	return 0;
}

