#include <plugapi.h>
#include <stdlib.h>
#include <stdio.h>

#define MY_NAME "plug_mul"
#define PREFIX "[" MY_NAME "] "

int mul(int x, int y)
{
	printf(PREFIX "Multiplying %d with %d in %s...\n", x, y, MY_NAME);
	return x * y;
}

int motion_plugin_load(void)
{
	printf(PREFIX "motion_plugin_load called for %s!\n", MY_NAME);
	return 1; /* init/load success */
}

void motion_plugin_unload(void)
{
	printf(PREFIX "motion_plugin_unload called for %s!\n", MY_NAME);
}

struct motion_plugin motion_plugin_info = {
	.name = MY_NAME,
	.version = "0.1",
	.author = "Per Jonsson",
	.homepage = "http://www.lavrsen.dk/twiki/bin/view/Motion",
	.flags = M_PLUGIN_MULTIPLY,  /* This is a multiplication plugin... */
	.api = {
		.mul_api.multiply = mul  /* ...so we adhere to the multiplication API! */
	}
};

